#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>

MODULE_DESCRIPTION( "Sample null device driver." );
MODULE_LICENSE( "GPL" );

static int   devmajor = 241;
static char* devname  = "newnull2";
static char* msg      = "module [newnull2.o]";


static struct file_operations newnulldev_fops = 
{
	owner   : THIS_MODULE,
};


/*
 * ⥸塼ν
 * insmod ˸ƤФ
 */
int 
init_module( void )
{
	if ( register_chrdev( devmajor, devname, &newnulldev_fops ) ) {
		printk( KERN_INFO "%s : register_chrdev failed\n" );
		return -EBUSY;
	}

      return 0;
}


/*
 * ⥸塼β
 * ⥸塼λȿ 0 ǤСrmmod ˸ƤФ
 */
void 
cleanup_module( void )
{
	if ( unregister_chrdev( devmajor, devname ) ) {
		printk( KERN_INFO "%s : unregister_chrdev failed\n" );
		/* к̵ ... */
	}

	printk( KERN_INFO "%s : removed from kernel\n", msg );
}


/* End of null.c */
